//BTN1 RANDOM NOTE AND VELOCITY
//BTN2 SEQ_PAGE NOTE AND VELOCITY/TRANSPOSE_LENGTH PAGE
//BTN3 STEP_UP_SEQ
//BTN4 STEP_DOWN_SEQ



#include <MidiTools.h>

RangeEncoder trkEncoder(0, 5, "TRK");
RangeEncoder lopEncoder(0, 127, "LOP");
RangeEncoder hipEncoder(0, 127, "HIP");
EncoderPage page(&trkEncoder,&lopEncoder,&hipEncoder);

void randomizeSynth() {
  for(int i=48;i<(48+7+1);i++) {
    MidiUart.sendCC(trkEncoder.getValue(),i,random(127));
  }

}

void randomizeFx() {
  for(int i=80;i<(80+8+1);i++) {
    MidiUart.sendCC(trkEncoder.getValue(),i,random(127));
  }

}

void randomizeAll() {
for(int j=0;j<6;j++) {
  for(int i=80;i<(80+8+1);i++) {
   if(i!=85) MidiUart.sendCC(j,i,random(127));
  }
    for(int i=48;i<(48+7+1);i++) {
    MidiUart.sendCC(j,i,random(127));
  }
}

}

void calmDown() {
for(int j=0;j<6;j++) {
    MidiUart.sendCC(j,85,0);
   // MidiUart.sendCC(j,81,63);
}

}

void setup() {

  GUI.setPage(&page);
  GUI.flash_strings_fill("HK Mono Random","Version 0.1");
}


void loop() {
  GUI.updatePage();
  if(lopEncoder.hasChanged()) {
    for(int j=0;j<6;j++) {
    MidiUart.sendCC(j,73,lopEncoder.getValue());
}
  }
   if(hipEncoder.hasChanged()) {
    for(int j=0;j<6;j++) {
    MidiUart.sendCC(j,72,hipEncoder.getValue());
}
  }
  GUI.update();
}

void handleGui() {
  if (BUTTON_PRESSED(Buttons.BUTTON1)) {
    GUI.flash_strings_fill("Random Synth","Version 0.1");
    randomizeSynth();
  }
  if (BUTTON_PRESSED(Buttons.BUTTON2)) {
    GUI.flash_strings_fill("Random Fx","Version 0.1");
    randomizeFx();
  }   
  if (BUTTON_PRESSED(Buttons.BUTTON3)) {
    GUI.flash_strings_fill("Random All","Version 0.1");
    randomizeAll();
  }   
   if (BUTTON_PRESSED(Buttons.BUTTON4)) {
    GUI.flash_strings_fill("Calm Down","Version 0.1");
   calmDown();
  }   
}
