//BTN1 RANDOM NOTE AND VELOCITY
//BTN2 SEQ_PAGE NOTE AND VELOCITY/TRANSPOSE_LENGTH PAGE
//BTN3 STEP_UP_SEQ
//BTN4 STEP_DOWN_SEQ



#include <MidiTools.h>

#include "WProgram.h"
void randomizeSynth();
void randomizeFx();
void randomizeAll();
void calmDown();
void setup();
void loop();
void handleGui();
RangeEncoder trkEncoder(0, 5, "TRK");
RangeEncoder lopEncoder(0, 127, "LOP");
RangeEncoder hipEncoder(0, 127, "HIP");
EncoderPage page(&trkEncoder,&lopEncoder,&hipEncoder);

void randomizeSynth() {
  for(int i=48;i<(48+7+1);i++) {
    MidiUart.sendCC(trkEncoder.getValue(),i,random(127));
  }

}

void randomizeFx() {
  for(int i=80;i<(80+8+1);i++) {
    MidiUart.sendCC(trkEncoder.getValue(),i,random(127));
  }

}

void randomizeAll() {
for(int j=0;j<6;j++) {
  for(int i=80;i<(80+8+1);i++) {
   if(i!=85) MidiUart.sendCC(j,i,random(127));
  }
    for(int i=48;i<(48+7+1);i++) {
    MidiUart.sendCC(j,i,random(127));
  }
}

}

void calmDown() {
for(int j=0;j<6;j++) {
    MidiUart.sendCC(j,85,0);
   // MidiUart.sendCC(j,81,63);
}

}

void setup() {

  GUI.setPage(&page);
  GUI.flash_strings_fill("HK Mono Random","Version 0.1");
}


void loop() {
  GUI.updatePage();
  if(lopEncoder.hasChanged()) {
    for(int j=0;j<6;j++) {
    MidiUart.sendCC(j,73,lopEncoder.getValue());
}
  }
   if(hipEncoder.hasChanged()) {
    for(int j=0;j<6;j++) {
    MidiUart.sendCC(j,72,hipEncoder.getValue());
}
  }
  GUI.update();
}

void handleGui() {
  if (BUTTON_PRESSED(Buttons.BUTTON1)) {
    GUI.flash_strings_fill("Random Synth","Version 0.1");
    randomizeSynth();
  }
  if (BUTTON_PRESSED(Buttons.BUTTON2)) {
    GUI.flash_strings_fill("Random Fx","Version 0.1");
    randomizeFx();
  }   
  if (BUTTON_PRESSED(Buttons.BUTTON3)) {
    GUI.flash_strings_fill("Random All","Version 0.1");
    randomizeAll();
  }   
   if (BUTTON_PRESSED(Buttons.BUTTON4)) {
    GUI.flash_strings_fill("Calm Down","Version 0.1");
   calmDown();
  }   
}

#include <Midi.h>

#include "WProgram.h"
#include <avr/interrupt.h>

void setup();
void loop();
void handleGui();

#define PHASE_FACTOR 16
static inline uint32_t phase_mult(uint32_t val) {
  return (val * PHASE_FACTOR) >> 8;
}

ISR(TIMER1_OVF_vect) {
  //  setLed2();

  clock++;
#ifdef MIDIDUINO_MIDI_CLOCK
  if (MidiClock.state == MidiClock.STARTED)
    MidiClock.handleTimerInt();
#endif

  //  clearLed2();
}

// XXX CMP to have better time

void gui_poll() {
  uint16_t sr = SR165.read16();
  Buttons.clear();
  Buttons.poll(sr >> 8);
  Encoders.poll(sr);
}

uint16_t lastRunningStatusReset = 0;

ISR(TIMER2_OVF_vect) {
  //  setLed2();

#ifdef MIDIDUINO_POLL_GUI_IRQ
  gui_poll();
  handleGui();
#endif
  slowclock++;

  if (abs(slowclock - lastRunningStatusReset) > 3000) {
    MidiUart.resetRunningStatus();
    lastRunningStatusReset = slowclock;
  }
  
  //  clearLed2();
}

MidiClass Midi;
MidiClass Midi2;

void __mainInnerLoop(bool callLoop) {
    if (MidiUart.avail()) {
      Midi.handleByte(MidiUart.getc());
    }

    if (MidiUart2.avail()) {
      Midi2.handleByte(MidiUart2.getc());
    }
    
#if defined(MIDIDUINO_POLL_GUI) && !defined(MIDIDUINO_POLL_GUI_IRQ)
    cli();
    gui_poll();
    handleGui();
    sei();
#endif

    if (callLoop)
      loop();
}

int main(void) {
    delay(100);
  init();
  clearLed();
  clearLed2();

  for (int i = 0; i < GUI_NUM_BUTTONS; i++) {
    SET_B_CURRENT(i);
  }

  MidiSysex.addSysexListener(&MididuinoSysexListener);
  setup();
  sei();

  for (;;) {
    __mainInnerLoop();
  }
  return 0;
}
